Index: /trunk/SophyaLib/NTools/NTools.o.list
===================================================================
--- /trunk/SophyaLib/NTools/NTools.o.list	(revision 895)
+++ /trunk/SophyaLib/NTools/NTools.o.list	(revision 896)
@@ -32,3 +32,2 @@
 simplesort.o
 tabmath.o
-utils.o
Index: /trunk/SophyaLib/NTools/cimage.h
===================================================================
--- /trunk/SophyaLib/NTools/cimage.h	(revision 895)
+++ /trunk/SophyaLib/NTools/cimage.h	(revision 896)
@@ -228,4 +228,5 @@
 }
 
+
 /*  .......................................................  */
 /*         Fonctions de copie d'images et de paves           */
@@ -294,4 +295,5 @@
 #endif
 
+
 #endif
 
Index: /trunk/SophyaLib/NTools/cspline.h
===================================================================
--- /trunk/SophyaLib/NTools/cspline.h	(revision 895)
+++ /trunk/SophyaLib/NTools/cspline.h	(revision 896)
@@ -8,5 +8,8 @@
 // Class CSpline et CSpline2 selon Numerical Receipes (cmv 17/02/97)
 ///////////////////////////////////////////////////////////////////
-class CSpline EXC_AWARE {
+namespace SOPHYA {
+
+//! Spline fit to a set of points Y=f(X) (as in Numerical Receipes).
+class CSpline {
 
 public:
@@ -71,5 +74,6 @@
 
 ///////////////////////////////////////////////////////////////////
-class CSpline2 EXC_AWARE {
+//! 2D Spline fit to a set of points Y=f(X1,X2) (as in Numerical Receipes).
+class CSpline2  {
 
 public:
@@ -116,3 +120,5 @@
 };
 
+} // Fin du namespace
+
 #endif /* CSPLINE_H_SEEN */
Index: /trunk/SophyaLib/NTools/dynccd.h
===================================================================
--- /trunk/SophyaLib/NTools/dynccd.h	(revision 895)
+++ /trunk/SophyaLib/NTools/dynccd.h	(revision 896)
@@ -8,7 +8,9 @@
 #include "ppersist.h"
 
+namespace SOPHYA {
+
 enum {kConstantNoise = 0, kPhotonNoise, kSigFondNoise, kSqrtADUNoise};
 
-class DynCCD EXC_AWARE
+class DynCCD 
 {
   public :
@@ -30,4 +32,6 @@
   float Noise(float pixel) const;
 };
+
+} // Fin du namespace
 
 // Quelques fonctions pour manipuler des images de bruit
@@ -63,3 +67,4 @@
 //STRUCTPERSISTIO(DynCCD, TypNoise, sizeof(int_4)+6*sizeof(float))
 
+
 #endif
Index: /trunk/SophyaLib/NTools/fftpserver.cc
===================================================================
--- /trunk/SophyaLib/NTools/fftpserver.cc	(revision 895)
+++ /trunk/SophyaLib/NTools/fftpserver.cc	(revision 896)
@@ -5,7 +5,6 @@
 
 
-/*! \class FFTPackServer
- \brief An FFT server based on fftpack
-
+/*! 
+\class SOPHYA::FFTPackServer
 A class that calculates Fourier transforms forwards and backwards.
 
@@ -16,6 +15,4 @@
 Otherwise, the output is in the fftpack format.
 
-Complex input must be entered using the <complex> template.  Otherwise,
-all input is assumed to be real.
 
 Due to the way that fftpack manages
@@ -26,5 +23,5 @@
 */
 
-/*! \fn virtual void FFTServer::fftf(int l, r_4* inout)
+/* \fn virtual void FFTServer::fftf(int l, r_4* inout)
   \param l length of array
   \param inout input array /output forward FFT (original array destroyed)
@@ -34,34 +31,34 @@
   \param inout input array /output backward FFT (original array destroyed)
 */
-/*! \fn virtual void FFTServer::fftf(int l, r_8* inout)
+/* \fn virtual void FFTServer::fftf(int l, r_8* inout)
   \param l length of array
   \param inout input array /output forward FFT (original array destroyed)
   \param inout input/output array (original array destroyed)
 */
-/*! \fn virtual void FFTServer::fftb(int l, r_8* inout)
+/* \fn virtual void FFTServer::fftb(int l, r_8* inout)
   \param l length of array
   \param inout input array /output backward FFT(original array destroyed)
 */
-/*!\fn  virtual void FFTServer::fftf(int l, complex<r_4>* inout)
+/*\fn  virtual void FFTServer::fftf(int l, complex<r_4>* inout)
   \param l length of array
   \param inout input array /output forward FFT (original array destroyed)
 */
-/*! \fn virtual void FFTServer::fftb(int l, complex<r_4>* inout)
+/* \fn virtual void FFTServer::fftb(int l, complex<r_4>* inout)
   \param l length of array
   \param inout input array /output backward FFT (original array destroyed)
 */
-/*! \fn virtual void FFTServer::fftf(int l, complex<r_8>* inout)
+/* \fn virtual void FFTServer::fftf(int l, complex<r_8>* inout)
   \param l length of array
   \param inout input array /output forward FFT (original array destroyed)
 */
-/*! \fn virtual void FFTServer::fftb(int l, complex<r_8>* inout)
+/* \fn virtual void FFTServer::fftb(int l, complex<r_8>* inout)
   \param l length of array
   \param inout input array /output backward FFT(original array destroyed)
 */
-/*!\fn  virtual void FFTServer::fftf(Vector& in, Vector& out)
+/*\fn  virtual void FFTServer::fftf(Vector& in, Vector& out)
   \param in input array
   \param out forward FFT
 */
-/*! \fn virtual void FFTServer::fftb(Vector& in, Vector& out)
+/* \fn virtual void FFTServer::fftb(Vector& in, Vector& out)
   \param in input array
   \param out backward FFT
Index: /trunk/SophyaLib/NTools/fftpserver.h
===================================================================
--- /trunk/SophyaLib/NTools/fftpserver.h	(revision 895)
+++ /trunk/SophyaLib/NTools/fftpserver.h	(revision 896)
@@ -8,4 +8,5 @@
 namespace SOPHYA {
 
+//! An FFT server based on fftpack.
 class FFTPackServer : public FFTServerInterface {
  public:
Index: /trunk/SophyaLib/NTools/rzimage.h
===================================================================
--- /trunk/SophyaLib/NTools/rzimage.h	(revision 895)
+++ /trunk/SophyaLib/NTools/rzimage.h	(revision 896)
@@ -15,5 +15,7 @@
 #include "dvlist.h"
 
-namespace SOPHYA {class GeneralFit;}
+namespace SOPHYA {
+class GeneralFit;
+}
 
 // Flags de verifications sur les indices 
@@ -231,3 +233,4 @@
 }
 
+
 #endif
Index: unk/SophyaLib/NTools/utils.cc
===================================================================
--- /trunk/SophyaLib/NTools/utils.cc	(revision 895)
+++ 	(revision )
@@ -1,112 +1,0 @@
-// This may look like C code, but it is really -*- C++ -*-
-//
-// $Id: utils.cc,v 1.2 1999-04-22 16:18:51 ansari Exp $
-//
-
-#include "machdefs.h"
-#include "utils.h"
-#include "pexceptions.h"
-#include <string.h>
-
-// MemCpy marche meme en cas de recouvrement.
-void* MemCpy(void* dest, const void* source, size_t n)
-{
-  int i;   // THINK C ne veut pas du int i dans chaque for...
-  if (dest < source)
-    for (i=0; i<n; i++)
-      ((char*)dest)[i] = ((char*)source)[i];
-  else 
-    for (i=n-1; i>=0; i--)
-      ((char*)dest)[i] = ((char*)source)[i];
-  
-  return dest;
-}
-
-// Dans parmst.cc
-//int PrtLevel = 0;
-//int DebugLevel = 0;
-
-char const* PeidaWorkPath()
-{
-  char const* envWP = getenv("PEIDAWORKPATH");
-  if (envWP) return envWP;
-  #ifdef __mac__
-  return "WORK";
-  #endif
-  return ".";
-}
-
-#ifndef __mac__
-void buildPath(char* dst, const char* dir, const char* file)
-{
-  strcpy(dst, dir);
-  char *p = dst; while (*p) p++; p--;
-  if (*dir && *p != '/') strcat(dst, "/");
-  strcat(dst, file);
-}
-
-void buildPath(string& dst, const string& dir, const string& file)
-{
-  dst = dir;
-  if (dir != "" && dir[dir.length()-1] != '/') dst += "/";
-  dst += file;
-}
-
-#else
-void buildPath(char* dst, const char* dir, const char* file)
-{
-  if (*dir) {
-    strcpy(dst, ":");
-    strcat(dst, dir);
-    char *p = dst; while (*p) p++; p--;
-    strcat(dst, ":");
-    strcat(dst, file);
-  } else
-    strcpy(dst, file);
-}
-
-void buildPath(string& dst, const string& dir, const string& file)
-{
-  if (dir != "") {
-    dst = ":" + dir + ":" + file;
-  } else
-    dst = file;
-}
-
-#endif
-
-
-void changeSuffix(char* file, const char* suffix)
-{
-  char *p = file;
-  while (*p) p++;
-  while (*p != '.' && p > file) p--;
-  if (*p != '.') 
-    strcat(file, suffix);
-  else
-    strcpy(p,suffix);
-}
-
-void changeSuffix(string& file, const string& suffix)
-{
-  size_t pos = file.rfind('.');
-  //  if (pos != NPOS) file.remove(pos);
-  if (pos != NPOS) file = file.substr(0,pos);
-  file += suffix;
-}
-
-string itos(int i)
-{
-  char s[20];
-  sprintf(s, "%d", i);
-  return s;
-}
-
-string ftos(double f)
-{
-  char s[20];
-  sprintf(s, "%g", f);
-  return s;
-}
-
-
Index: unk/SophyaLib/NTools/utils.h
===================================================================
--- /trunk/SophyaLib/NTools/utils.h	(revision 895)
+++ 	(revision )
@@ -1,53 +1,0 @@
-// This may look like C code, but it is really -*- C++ -*-
-//
-// $Id: utils.h,v 1.3 1999-10-21 15:25:53 ansari Exp $
-//
-
-#ifndef UTILS_EA
-#define UTILS_EA
-
-#include "machdefs.h"
-#include <string.h>
-#include <string>
-#include <stdlib.h>
-#include <stdio.h>
-
-
-// MemCpy marche meme en cas de recouvrement.
-// #define memcpy MemCpy
-
-void* MemCpy(void* dest, const void* source, size_t n);
-
-char const* PeidaWorkPath();
-void buildPath(char* dst, const char* dir, const char* file);
-void buildPath(string& dst, const string& dir, const string& file);
-void changeSuffix(char* file, const char* suffix);
-void changeSuffix(string& file, const string& suffix);
-string itos(int);
-string ftos(double);
-
-inline void GetIntEnv(char const* s, int& v)
-{
-  char* pdeb = getenv(s);
-  if (pdeb) v = atoi(pdeb);
-}
-
-/* if defined(__DECCXX) || defined(__xlC) */
-#if defined(__xlC) || defined(__DECCXX)
-#define STRUCTCOMP(s)                        \
-  bool operator==(s const& b) const          \
-{ return memcmp(this, &b, sizeof(s)) == 0; } \
-  bool operator<(s const& b) const           \
-{ return memcmp(this, &b, sizeof(s)) < 0; } 
-  
-#define STRUCTCOMPF(s,f)                        \
-  bool operator==(s const& b) const          \
-{ return f == b.f; }                          \
-  bool operator<(s const& b) const           \
-{ return f < b.f; }
-#else
-#define STRUCTCOMP(s) 
-#define STRUCTCOMPF(s,f)
-#endif
-
-#endif // UTILS_EA