Index: /trunk/SophyaLib/SkyT/blackbody.h
===================================================================
--- /trunk/SophyaLib/SkyT/blackbody.h	(revision 900)
+++ /trunk/SophyaLib/SkyT/blackbody.h	(revision 901)
@@ -2,5 +2,5 @@
 //--------------------------------------------------------------------------
 // File and Version Information:
-//      $Id: blackbody.h,v 1.4 1999-11-29 16:59:10 ansari Exp $
+//      $Id: blackbody.h,v 1.5 2000-04-13 08:17:02 ansari Exp $
 //
 // Description:
@@ -16,5 +16,5 @@
 #include "radspec.h"
 #include "convtools.h"
-
+namespace SOPHYA {
 class BlackBody : public RadSpectra
 {
@@ -40,4 +40,4 @@
 
 };
-
+}
 #endif
Index: /trunk/SophyaLib/SkyT/convtools.h
===================================================================
--- /trunk/SophyaLib/SkyT/convtools.h	(revision 900)
+++ /trunk/SophyaLib/SkyT/convtools.h	(revision 901)
@@ -2,5 +2,5 @@
 //--------------------------------------------------------------------------
 // File and Version Information:
-//      $Id: convtools.h,v 1.2 1999-11-20 21:00:48 ansari Exp $
+//      $Id: convtools.h,v 1.3 2000-04-13 08:17:02 ansari Exp $
 //
 // Description:
@@ -14,5 +14,5 @@
 #ifndef CONV_TOOLS_H_SEEN
 #define CONV_TOOLS_H_SEEN
-
+namespace SOPHYA {
 class ConvTools
 {
@@ -24,3 +24,4 @@
 
 };
+}
 #endif
Index: /trunk/SophyaLib/SkyT/derivblackbody.h
===================================================================
--- /trunk/SophyaLib/SkyT/derivblackbody.h	(revision 900)
+++ /trunk/SophyaLib/SkyT/derivblackbody.h	(revision 901)
@@ -2,5 +2,5 @@
 //--------------------------------------------------------------------------
 // File and Version Information:
-//      $Id: derivblackbody.h,v 1.1 2000-04-11 13:26:05 ansari Exp $
+//      $Id: derivblackbody.h,v 1.2 2000-04-13 08:17:03 ansari Exp $
 //
 // Description:
@@ -16,5 +16,5 @@
 #include "radspec.h"
 #include "convtools.h"
-
+namespace SOPHYA {
 class DerivBlackBody : public RadSpectra
 {
@@ -40,4 +40,4 @@
 
 };
-
+}
 #endif
Index: /trunk/SophyaLib/SkyT/nupower.h
===================================================================
--- /trunk/SophyaLib/SkyT/nupower.h	(revision 900)
+++ /trunk/SophyaLib/SkyT/nupower.h	(revision 901)
@@ -2,5 +2,5 @@
 //--------------------------------------------------------------------------
 // File and Version Information:
-//      $Id: nupower.h,v 1.5 1999-11-29 16:59:10 ansari Exp $
+//      $Id: nupower.h,v 1.6 2000-04-13 08:17:03 ansari Exp $
 //
 // Description:
@@ -16,5 +16,5 @@
 #include "radspec.h"
 #include "convtools.h"
-
+namespace SOPHYA {
 // Power law spectra  f = a ((nu-nu0)/dnu)^b   
 class PowerLawSpectra : public RadSpectra
@@ -41,4 +41,4 @@
   double _a, _b, _nu0, _dnu;
 };
-
+}
 #endif
Index: /trunk/SophyaLib/SkyT/radspec.h
===================================================================
--- /trunk/SophyaLib/SkyT/radspec.h	(revision 900)
+++ /trunk/SophyaLib/SkyT/radspec.h	(revision 901)
@@ -2,5 +2,5 @@
 //--------------------------------------------------------------------------
 // File and Version Information:
-//      $Id: radspec.h,v 1.4 1999-11-29 16:59:11 ansari Exp $
+//      $Id: radspec.h,v 1.5 2000-04-13 08:17:03 ansari Exp $
 //
 // Description:
@@ -25,5 +25,5 @@
 // ***IMPORTANT*** All frequencies are expressed in GHz  (10^9 Hz)
 //                 and flux in Watt/m^2/sr
-
+namespace SOPHYA {
 class RadSpectra
 {
@@ -85,5 +85,5 @@
 inline ostream& operator << (ostream& s,  RadSpectra const & rs)
   {  rs.Print(s);  return(s);  }
-
+}
 
 #endif
Index: /trunk/SophyaLib/SkyT/radspecvector.h
===================================================================
--- /trunk/SophyaLib/SkyT/radspecvector.h	(revision 900)
+++ /trunk/SophyaLib/SkyT/radspecvector.h	(revision 901)
@@ -24,5 +24,5 @@
 // ***IMPORTANT*** All frequencies are expressed in GHz  (10^9 Hz)
 //                 and flux in Watt/m^2/sr
-
+namespace SOPHYA {
 class RadSpectraVec : public RadSpectra
 {
@@ -57,4 +57,4 @@
   Vector _vecOfFDeNu;
 };
-
+}
 #endif
Index: /trunk/SophyaLib/SkyT/squarefilt.h
===================================================================
--- /trunk/SophyaLib/SkyT/squarefilt.h	(revision 900)
+++ /trunk/SophyaLib/SkyT/squarefilt.h	(revision 901)
@@ -2,5 +2,5 @@
 //--------------------------------------------------------------------------
 // File and Version Information:
-//      $Id: squarefilt.h,v 1.4 1999-11-29 16:59:13 ansari Exp $
+//      $Id: squarefilt.h,v 1.5 2000-04-13 08:17:03 ansari Exp $
 //
 // Description:
@@ -26,5 +26,5 @@
 //              -- Class Interface --
 //              ---------------------
-
+namespace SOPHYA {
 class SquareFilter:public SpectralResponse
 {
@@ -53,4 +53,4 @@
 };
 
-
+}
 #endif
Index: /trunk/SophyaLib/SkyT/trianglefilt.h
===================================================================
--- /trunk/SophyaLib/SkyT/trianglefilt.h	(revision 900)
+++ /trunk/SophyaLib/SkyT/trianglefilt.h	(revision 901)
@@ -2,5 +2,5 @@
 //--------------------------------------------------------------------------
 // File and Version Information:
-//      $Id: trianglefilt.h,v 1.4 1999-11-29 16:59:13 ansari Exp $
+//      $Id: trianglefilt.h,v 1.5 2000-04-13 08:17:04 ansari Exp $
 //
 // Description:
@@ -25,5 +25,5 @@
 //              -- Class Interface --
 //              ---------------------
-
+namespace SOPHYA {
 class TriangleFilter:public SpectralResponse
 {
@@ -49,5 +49,5 @@
 };
 
-
+}
 
 #endif